
package de.ivu.elect.business.ergebnis.boundary;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Event;
import javax.inject.Inject;
import javax.inject.Named;


import de.ivu.elect.business.ergebnis.entity.Ergebnis;

@RequestScoped
@Named(ErgebnisSessionSelect.COMPONENT_NAME)
public class ErgebnisSessionSelect implements java.io.Serializable  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisSessionSelect";

  @Inject
  protected transient ErgebnisExtendedDAO entityDAO;

  @Inject
  protected transient ErgebnisSessionStore sessionStore;

  @Inject
  protected transient Event<ErgebnisSelectChangeEvent> entitySelectChangeEvent;

  private transient Boolean selectedCache = null;

  public ErgebnisSessionSelect() {
    super();
  }

  public boolean isSelected() {
    if (selectedCache == null) { // NPE beim Löschen von Entitäten verhindern
      if (getEntityPK() == null) {
        selectedCache = false;
      } else {
        selectedCache = getEntity() != null;
      }
    }

    return selectedCache;
  }

  public Ergebnis getEntity() {
    return getEntityInternal();
  }

  private Ergebnis getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Ergebnis entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.ergebnis.entity.ErgebnisPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Ergebnis entity) {
    if (entity == null && getEntityPK() != null) {
      changeEntityPkFireEvent(null, null);
    } else if (entity != null && !entity.getPk().equals(getEntityPK())) {
      if (isSetzenErlaubt(entity)){
        changeEntityPkFireEvent(entity, entity.getPk());
      }
    }
  }

  public
    de.ivu.elect.business.ergebnis.entity.ErgebnisPK
   getEntityPK() {
    return sessionStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.ergebnis.entity.ErgebnisPK
   entityPK) {
    selectedCache = null;
    sessionStore.setEntityPK(entityPK);
  }

  protected Ergebnis attach(Ergebnis entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Ergebnis attach( de.ivu.elect.business.ergebnis.entity.ErgebnisPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public boolean isSetzenErlaubt(Ergebnis entity) {
    return true; // Überschreiben, wenn etwas geprüft werden soll...
  }

  private void changeEntityPkFireEvent(Ergebnis neueEntity,
    de.ivu.elect.business.ergebnis.entity.ErgebnisPK
    neueEntityPK) {
    final Ergebnis alteEntity = getEntityInternal();
    setEntityPK(neueEntityPK);
    entitySelectChangeEvent.fire(new ErgebnisSelectChangeEvent(alteEntity, neueEntity));
  }
}
